## bio-eagle 2.3

=== src/Makefile ===
# build options:
# 1. cmd line: linking = dynamic (default), static-except-glibc (recommended release), static
# 2. cmd line: debug = false (default => -O2), true (-g)


### modify these paths to local BLAS, Boost and htslib install directories
LBLAS = -lopenblas # alternatively -llapack (just need sgemm_)
BLAS_DIR = /opt/openblas/0.2.14/lib
BOOST_INSTALL_DIR = /home/pl88/boost_1_58_0/install
HTSLIB_DIR = /groups/price/poru/external_software/htslib/htslib-1.3


### these paths are used only for static linking
ZLIB_STATIC_DIR = /opt/zlib-1.2.8/lib # probably unnecessary on most systems
GLIBC_STATIC_DIR = /home/pl88/glibc-static/usr/lib64


ifeq ($(strip ${linking}),)
	linking = dynamic
endif

CC = g++

ifeq (${debug},true)
	CFLAGS += -g
else
	CFLAGS += -O2
endif
ifeq (${prof},true)
	CFLAGS += -g -pg
	LFLAGS += -pg
endif

CFLAGS += -std=c++0x -msse -msse2 -fopenmp -Wall
LFLAGS += -fopenmp


# add BLAS lib path
ifneq ($(strip ${BLAS_DIR}),)
	LPATHS += -L${BLAS_DIR}
	ifeq (${linking},dynamic)
		LPATHS += -Wl,-rpath,${BLAS_DIR}
	endif
endif

# add Boost include and lib paths
ifneq ($(strip ${BOOST_INSTALL_DIR}),)
	CPATHS += -I${BOOST_INSTALL_DIR}/include
	LPATHS += -L${BOOST_INSTALL_DIR}/lib
	ifeq (${linking},dynamic)
		LPATHS += -Wl,-rpath,${BOOST_INSTALL_DIR}/lib
	endif
endif

# add htslib include and lib paths
ifneq ($(strip ${HTSLIB_DIR}),)
	CPATHS += -I${HTSLIB_DIR}
	LPATHS += -L${HTSLIB_DIR}
	ifeq (${linking},dynamic)
		LPATHS += -Wl,-rpath,${HTSLIB_DIR}
	endif
endif

# add zlib.a path for static linking on Orchestra
ifneq ($(strip ${ZLIB_STATIC_DIR}),)
	ifneq (${linking},dynamic)
		LPATHS += -L${ZLIB_STATIC_DIR}
	endif
endif

# add flags for static linking; build LAPACK/MKL component of link line
ifeq (${linking},static)
	LFLAGS += -static
	LPATHS += -L${GLIBC_STATIC_DIR} -L${ZLIB_STATIC_DIR}
else ifeq (${linking},static-except-glibc)
	LFLAGS += -static-libgcc -static-libstdc++
	LPATHS += -L${ZLIB_STATIC_DIR}
endif

# build link line (minus flags)
LLIBS = -lhts -lboost_program_options -lboost_iostreams -lz ${LBLAS}
ifeq (${linking},static-except-glibc)
	L = ${LPATHS} -Wl,-Bstatic ${LLIBS} -Wl,-Bdynamic -lpthread -lm
else
	L = ${LPATHS} ${LLIBS} -lpthread -lm
endif


T = eagle
O = DipTreePBWT.o Eagle.o EagleImpMiss.o EagleParams.o EaglePBWT.o FileUtils.o GenoData.o HapHedge.o MapInterpolater.o MemoryUtils.o NumericUtils.o StaticMultimap.o StringUtils.o SyncedVcfData.o Timer.o
OMAIN = EagleMain.o $O

.PHONY: clean

$T: ${OMAIN}
	${CC} ${LFLAGS} -o $T ${OMAIN} $L

%.o: %.cpp
	${CC} ${CFLAGS} ${CPATHS} -o $@ -c $<
EagleMain.o: Version.hpp
Eagle.o: Version.hpp

all: $T

clean:
	rm -f *.o
	rm -f $T

=== debian/changelog ===
bio-eagle (2.3-3) unstable; urgency=medium

  * Remove the test which creates a false positive in the autopkgtest
    by emitting some warnings. (Closes: #842356)

 -- Dylan Aïssi <bob.dybian@gmail.com>  Sun, 30 Oct 2016 23:26:33 +0100

bio-eagle (2.3-2) unstable; urgency=medium

  * Add a comment in the description about the renaming.
  * Fix the test.
  * Remove the field Testsuite in d/control.
  * Add "Multi-Arch: foreign" for the bio-eagle-examples package.
  * Update Makefile_config.patch to fortify functions.

 -- Dylan Aïssi <bob.dybian@gmail.com>  Thu, 27 Oct 2016 21:56:43 +0200

bio-eagle (2.3-1) unstable; urgency=medium

  * Initial release. (Closes: #838070)

 -- Dylan Aïssi <bob.dybian@gmail.com>  Sun, 18 Sep 2016 23:08:34 +0200

=== debian/control ===
Source: bio-eagle
Section: science
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Dylan Aïssi <bob.dybian@gmail.com>
Build-Depends: debhelper (>= 9),
 libopenblas-dev,
 libboost-dev,
 libboost-iostreams-dev,
 libboost-program-options-dev,
 libhts-dev,
 zlib1g-dev
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/git/debian-med/eagle.git
Vcs-Git: https://anonscm.debian.org/git/debian-med/eagle.git
Homepage: https://data.broadinstitute.org/alkesgroup/Eagle/

Package: bio-eagle
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: med-config (>= 2.1)
Suggests: bio-eagle-examples
Description: Haplotype phasing within a genotyped cohort or using a phased reference panel
 Eagle estimates haplotype phase either within a genotyped cohort or using a
 phased reference panel. The basic idea of the Eagle1 algorithm is to harness
 identity-by-descent among distant relatives—which is pervasive at very large
 sample sizes but rare among smaller numbers of samples—to rapidly call phase
 using a fast scoring approach. In contrast, the Eagle2 algorithm analyzes a
 full probabilistic model similar to the diploid Li-Stephens model used by
 previous HMM-based methods.
 .
 Please note: The executable was renamed to bio-eagle because of a name clash.
 Please read more about this in /usr/share/doc/bio-eagle/README.Debian.

Package: bio-eagle-examples
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Enhances: bio-eagle
Description: Examples for bio-eagle
 Eagle estimates haplotype phase either within a genotyped cohort or using a
 phased reference panel. The basic idea of the Eagle1 algorithm is to harness
 identity-by-descent among distant relatives—which is pervasive at very large
 sample sizes but rare among smaller numbers of samples—to rapidly call phase
 using a fast scoring approach. In contrast, the Eagle2 algorithm analyzes a
 full probabilistic model similar to the diploid Li-Stephens model used by
 previous HMM-based methods.
 .
 This package provides some example data for eagle.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --sourcedirectory=src

override_dh_installchangelogs:
	dh_installchangelogs debian/upstream.changelog

get-orig-source-git-snapshot:
	wget https://github.com/poruloh/Eagle/archive/master.tar.gz
	# mv master.tar.gz bio-eagle_2.3+git160722.orig.tar.gz

=== debian/watch ===
version=3
 https://data.broadinstitute.org/alkesgroup/Eagle/downloads/ Eagle_v(\d\S*)\.tar\.gz

## bio-eagle 2.3.5

=== debian/changelog ===
bio-eagle (2.3.5-1) unstable; urgency=medium

  * New upstream release.
  * Correct OMICtools ref.
  * cme fix dpkg-control.

 -- Dylan Aïssi <bob.dybian@gmail.com>  Wed, 16 Aug 2017 22:50:28 +0200

bio-eagle (2.3.4-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version: 4.0.0 (no changes needed).
  * Add OMICtools ref.

 -- Dylan Aïssi <bob.dybian@gmail.com>  Mon, 24 Jul 2017 21:30:51 +0200

bio-eagle (2.3.2-1) unstable; urgency=medium

  * New upstream release.
  * Bump Build-Depends: libhts-dev to >= 1.4.
  * Upload to unstable, Stretch freeze is over.

 -- Dylan Aïssi <bob.dybian@gmail.com>  Sun, 25 Jun 2017 00:32:48 +0200

bio-eagle (2.3.1-1) experimental; urgency=medium

  * New upstream release.
  * Update d/watch to v4 and target github.
  * Update d/copyright: 2017.
  * Remove Fix_FTBFS.patch and Clarify_license.patch upstream fixed.
  * Bump debhelper compat 10.

 -- Dylan Aïssi <bob.dybian@gmail.com>  Sun, 05 Mar 2017 22:42:55 +0100

=== debian/control ===
--- 
+++ 
@@ -1,23 +1,24 @@
 Source: bio-eagle
+Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Uploaders: Dylan Aïssi <bob.dybian@gmail.com>
 Section: science
 Priority: optional
-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Dylan Aïssi <bob.dybian@gmail.com>
-Build-Depends: debhelper (>= 9),
- libopenblas-dev,
- libboost-dev,
- libboost-iostreams-dev,
- libboost-program-options-dev,
- libhts-dev,
- zlib1g-dev
-Standards-Version: 3.9.8
-Vcs-Browser: https://anonscm.debian.org/git/debian-med/eagle.git
+Build-Depends: debhelper (>= 10),
+               libopenblas-dev,
+               libboost-dev,
+               libboost-iostreams-dev,
+               libboost-program-options-dev,
+               libhts-dev (>= 1.4),
+               zlib1g-dev
+Standards-Version: 4.0.1
+Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/eagle.git
 Vcs-Git: https://anonscm.debian.org/git/debian-med/eagle.git
 Homepage: https://data.broadinstitute.org/alkesgroup/Eagle/
 
 Package: bio-eagle
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${shlibs:Depends},
+         ${misc:Depends}
 Recommends: med-config (>= 2.1)
 Suggests: bio-eagle-examples
 Description: Haplotype phasing within a genotyped cohort or using a phased reference panel

## bio-eagle 2.4

=== src/Makefile ===
--- 
+++ 
@@ -7,8 +7,8 @@
 LBLAS = -lopenblas # alternatively -llapack (just need sgemm_)
 BLAS_DIR = /opt/openblas/0.2.14/lib
 BOOST_INSTALL_DIR = /home/pl88/boost_1_58_0/install
-HTSLIB_DIR = /groups/price/poru/external_software/htslib/htslib-1.3
-
+HTSLIB_DIR = /groups/price/poru/external_software/htslib/htslib-1.4
+### NOTE: to reduce dependencies from htslib, configure htslib with: ./configure --disable-bz2 --disable-lzma --disable-plugins --disable-libcurl --disable-gcs --disable-s3
 
 ### these paths are used only for static linking
 ZLIB_STATIC_DIR = /opt/zlib-1.2.8/lib # probably unnecessary on most systems

=== debian/changelog ===
bio-eagle (2.4-1) unstable; urgency=medium

  * New upstream release.
  * Restrict building architecture to x86, upstream supports only x86 arch.
  * Bump Standards-Version: 4.1.3 (no changes needed).
  * Bump debhelper compat 11.

 -- Dylan Aïssi <bob.dybian@gmail.com>  Fri, 12 Jan 2018 23:33:14 +0100

=== debian/control ===
--- 
+++ 
@@ -3,20 +3,20 @@
 Uploaders: Dylan Aïssi <bob.dybian@gmail.com>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 10),
+Build-Depends: debhelper (>= 11),
                libopenblas-dev,
                libboost-dev,
                libboost-iostreams-dev,
                libboost-program-options-dev,
                libhts-dev (>= 1.4),
                zlib1g-dev
-Standards-Version: 4.0.1
+Standards-Version: 4.1.3
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/eagle.git
 Vcs-Git: https://anonscm.debian.org/git/debian-med/eagle.git
 Homepage: https://data.broadinstitute.org/alkesgroup/Eagle/
 
 Package: bio-eagle
-Architecture: any
+Architecture: any-amd64 any-i386
 Depends: ${shlibs:Depends},
          ${misc:Depends}
 Recommends: med-config (>= 2.1)

## bio-eagle 2.4.1

=== src/Makefile ===
--- 
+++ 
@@ -2,16 +2,26 @@
 # 1. cmd line: linking = dynamic (default), static-except-glibc (recommended release), static
 # 2. cmd line: debug = false (default => -O2), true (-g)
 
+# NOTE 12/7/17: on O2, can do 'module load gcc/6.2.0' to get installed lstdc++-static
+# ... but GCC 6.2.0 requires GOMP 4.0 + GLIBC 2.14
+# BOOST_INSTALL_DIR = /n/groups/price/poru/external_software/boost/boost_1_65_1/install
+# boost_1_65_1 was installed using GCC 6.2.0
 
 ### modify these paths to local BLAS, Boost and htslib install directories
 LBLAS = -lopenblas # alternatively -llapack (just need sgemm_)
-BLAS_DIR = /opt/openblas/0.2.14/lib
+BLAS_DIR = /n/app/openblas/0.2.19/lib # or /n/groups/price/poru/external_software/openblas/0.2.14/lib (copied from Orchestra /opt/openblas/0.2.14/lib)
+
 BOOST_INSTALL_DIR = /home/pl88/boost_1_58_0/install
-HTSLIB_DIR = /groups/price/poru/external_software/htslib/htslib-1.4
+# boost_1_58_0 was installed using GCC 4.8.5?
+
+HTSLIB_DIR = /n/groups/price/poru/external_software/htslib/htslib-1.9
 ### NOTE: to reduce dependencies from htslib, configure htslib with: ./configure --disable-bz2 --disable-lzma --disable-plugins --disable-libcurl --disable-gcs --disable-s3
 
-### these paths are used only for static linking
-ZLIB_STATIC_DIR = /opt/zlib-1.2.8/lib # probably unnecessary on most systems
+### only for static linking (unnecessary in a local install; probably unnecessary on most systems)
+ZLIB_STATIC_DIR = /n/groups/price/poru/external_software/zlib/zlib-1.2.11
+LIBSTDCXX_STATIC_DIR = /n/groups/price/poru/external_software/libstdc++/usr/lib/gcc/x86_64-redhat-linux/4.8.5/
+
+### only for linking=static, which is discouraged
 GLIBC_STATIC_DIR = /home/pl88/glibc-static/usr/lib64
 
 
@@ -71,23 +81,22 @@
 # add flags for static linking; build LAPACK/MKL component of link line
 ifeq (${linking},static)
 	LFLAGS += -static
-	LPATHS += -L${GLIBC_STATIC_DIR} -L${ZLIB_STATIC_DIR}
+	LPATHS += -L${GLIBC_STATIC_DIR}
 else ifeq (${linking},static-except-glibc)
 	LFLAGS += -static-libgcc -static-libstdc++
-	LPATHS += -L${ZLIB_STATIC_DIR}
 endif
 
 # build link line (minus flags)
 LLIBS = -lhts -lboost_program_options -lboost_iostreams -lz ${LBLAS}
 ifeq (${linking},static-except-glibc)
-	L = ${LPATHS} -Wl,-Bstatic ${LLIBS} -Wl,-Bdynamic -lpthread -lm
+	L = -L${LIBSTDCXX_STATIC_DIR} ${LPATHS} -Wl,--wrap=memcpy -Wl,-Bstatic ${LLIBS} -Wl,-Bdynamic -lpthread -lm
 else
 	L = ${LPATHS} ${LLIBS} -lpthread -lm
 endif
 
 
 T = eagle
-O = DipTreePBWT.o Eagle.o EagleImpMiss.o EagleParams.o EaglePBWT.o FileUtils.o GenoData.o HapHedge.o MapInterpolater.o MemoryUtils.o NumericUtils.o StaticMultimap.o StringUtils.o SyncedVcfData.o Timer.o
+O = DipTreePBWT.o Eagle.o EagleImpMiss.o EagleParams.o EaglePBWT.o FileUtils.o GenoData.o HapHedge.o MapInterpolater.o MemoryUtils.o NumericUtils.o StaticMultimap.o StringUtils.o SyncedVcfData.o Timer.o memcpy.o
 OMAIN = EagleMain.o $O
 
 .PHONY: clean

=== debian/changelog ===
bio-eagle (2.4.1-3build4) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 06 Aug 2025 17:10:23 +0200

bio-eagle (2.4.1-3build3) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 06 Aug 2025 16:59:58 +0200

bio-eagle (2.4.1-3build2) noble; urgency=medium

  * No-change rebuild for boost defaults change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 19 Dec 2023 15:46:30 +0100

bio-eagle (2.4.1-3build1) hirsute; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 12 Dec 2020 13:03:30 +0100

bio-eagle (2.4.1-3) unstable; urgency=medium

  [ Andreas Tille ]
  * Team upload.
  * Standards-Version: 4.5.1 (routine-update)
  * Do nothing in dh_auto_configure and dh_auto_build for indep binaries
    Closes: #976572

  [ Michael R. Crusoe ]
  * Add patch for compilation on systems without SSE.
    Use of "rdtsc" assembly still makes it x86 specific.

 -- Andreas Tille <tille@debian.org>  Sat, 05 Dec 2020 22:31:32 +0100

bio-eagle (2.4.1-2) unstable; urgency=medium

  * Team upload.
  * Test only on available architectures
  * Standards-Version: 4.5.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Remove obsolete fields Contact, Name from debian/upstream/metadata (already
    present in machine-readable debian/copyright).
  * Replace use of deprecated $ADTTMP with $AUTOPKGTEST_TMP.

 -- Andreas Tille <tille@debian.org>  Fri, 06 Nov 2020 15:48:02 +0100

bio-eagle (2.4.1-1) unstable; urgency=medium

  * New upstream release.
  * Update my email address.

 -- Dylan Aïssi <daissi@debian.org>  Wed, 28 Nov 2018 07:56:36 +0100

bio-eagle (2.4-2) unstable; urgency=medium

  * Team upload

  [ Steffen Moeller ]
  * d/u/metadata:
    - added RRIDs
    - yamllint clean

  [ Andreas Tille ]
  * Point Vcs fields to salsa.debian.org (moved from dir eagle to bio-eagle)
  * Standards-Version: 4.2.1

 -- Andreas Tille <tille@debian.org>  Thu, 13 Sep 2018 08:50:04 +0200

=== debian/control ===
--- 
+++ 
@@ -1,19 +1,20 @@
 Source: bio-eagle
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Dylan Aïssi <bob.dybian@gmail.com>
+Uploaders: Dylan Aïssi <daissi@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 11),
+Build-Depends: debhelper-compat (= 13),
                libopenblas-dev,
                libboost-dev,
                libboost-iostreams-dev,
                libboost-program-options-dev,
                libhts-dev (>= 1.4),
                zlib1g-dev
-Standards-Version: 4.1.3
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/eagle.git
-Vcs-Git: https://anonscm.debian.org/git/debian-med/eagle.git
+Standards-Version: 4.5.1
+Vcs-Browser: https://salsa.debian.org/med-team/bio-eagle
+Vcs-Git: https://salsa.debian.org/med-team/bio-eagle.git
 Homepage: https://data.broadinstitute.org/alkesgroup/Eagle/
+Rules-Requires-Root: no
 
 Package: bio-eagle
 Architecture: any-amd64 any-i386

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --sourcedirectory=src

override_dh_auto_configure-indep:
override_dh_auto_build-indep:
override_dh_auto_install-indep:
	echo "I: Nothing to do for arch:indep binary"

override_dh_installchangelogs:
	dh_installchangelogs debian/upstream.changelog

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/Eagle-$1\.tar\.gz/ \
  https://github.com/poruloh/Eagle/tags .*/v?(\d\S+)\.tar\.gz
